# Korean word embedding vectors for 'KMA tokenized text file'.
# model_name = 'FastText-KCC150.model'	# Word2Vec model
# C> wv_model_test.py 'FastText-KCC150.model'

from gensim.models import Word2Vec
import sys

def test():
		#print(model.wv.get_vector(u'배우'))
		#print(model.wv.get_vector(u'여배우'))
		print(model.wv.similarity(u'배우', u'여배우'))
		print(model.wv.similarity(u'배우', u'남자'))
		print(model.wv.similarity(u'남자', u'여배우'))

		print(model.wv.most_similar(positive=[u'남자'], topn=5))
		# calculate: (남자 - 배우) + 여배우 = ?
		print(model.wv.most_similar(positive=[u'남자', u'여배우'], negative=[u'배우'], topn=5))
		print(model.wv.most_similar(positive=[u'여왕', u'남자'], negative=[u'여자'], topn=10))

		word = "혐오"
		key_list = model.wv.key_to_index.keys()
		if word in key_list:
				print(model.wv.most_similar(positive=[word], topn=5))


def term_expansion_dict(term, n):
		# Similary word expansion to dictionary
		rel_terms = model.wv.most_similar(positive=[term], topn=n)
		dic_terms = {}
		for i, t in enumerate(rel_terms):
				if t[0] not in dic_terms:
						dic_terms[t[0]] = [(t[1], term)]
				else:
						dic_terms[t[0]].append((t[1], term))
		
		#print(term, dic_terms)
		return dic_terms


def term_expansion_list(term, model, n, min_similarity):
		# Similary word expansion to term list
		rel_terms = model.wv.most_similar(positive=[term], topn=n)
		lst_terms = []
		for t in rel_terms:
				#print(t, ':', t[0], t[1])
				if t[1] >= min_similarity:
						lst_terms.append(t[0])

		return lst_terms


if __name__ == "__main__":
		print("\nLoading word embedding vectors...\n")

		seed_term = "혐오"		# seed term for expansion
		model_name = "model/FastText-KCC150.model"
		if len(sys.argv) >= 2:
				if 'a' <= sys.argv[1].lower() <= "z":
						model_name = sys.argv[1]	# Word2Vec model
				else:
						seed_term = sys.argv[1]
		model = Word2Vec.load(model_name)

		#test()

		#dic_terms = term_expansion_dict(seed_term, 10)
		#print(seed_term, 'dict -->', dic_terms, '\n')

		term_list = term_expansion_list(seed_term, model, n=500, min_similarity=0.4)
		#print(seed_term, '-->', term_list, '\n', set(term_list), '\n')

		term_set = { seed_term }
		term_set.update(term_list)
		print('Terms =', term_set, '\n', len(term_set))

		for term in term_list:
				t = term_expansion_list(term, model, n=500, min_similarity=0.6)
				term_set.update(t)
		print('Terms =', term_set, '\n', len(term_set))
